build.sh 12 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314
  1. #!/bin/bash
  2. # (c) 2014-2016 Freifunk Hochstift <kontakt@hochstift.freifunk.net>
  3. #
  4. # This script builds the firmware by the environment variables given, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  10. #
  11. # optional:
  12. # AUTOUPDATER = force Autoupdater Branch (stable/testing/experimental/off)
  13. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  14. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  15. # CLEAN = 'dirclean' to perform "make dirclean" before build or 'clean' to perform "make clean" (BRANCH==stable/testing) or 'none' (BRANCH==experimental)
  16. # KEY_DIR = specify directory for gluon-opkg-key
  17. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  18. # PRIORITY = determines the number of day a rollout phase should last at most
  19. # PUBLISH = 0 (default) or 1, publish firmware at the end
  20. # SITE_ID = specific site repository commit-id (leave blank to use HEAD)
  21. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  22. # VERBOSE = 0 (default) or 1, call the make commands with 'V=s' to see actual errors better
  23. # VERSIONS_DIR = specify directory for version files
  24. #
  25. ### includes
  26. . functions.sh
  27. ### static variables
  28. MY_DIR=$(dirname $0)
  29. MY_DIR=$(readlink -f "${MY_DIR}")
  30. DEFAULT_KEY_DIR="${MY_DIR}/opkg-keys"
  31. DEFAULT_VERSIONS_DIR="${MY_DIR}/versions"
  32. CODE_DIR="${MY_DIR}/src"
  33. GLUON_BUILD_DIR="${CODE_DIR}/build"
  34. SITE_DIR="${CODE_DIR}/site"
  35. PATCH_DIR="${SITE_DIR}/patches"
  36. OUTPUT_DIR="${MY_DIR}/output"
  37. IMAGE_DIR="${CODE_DIR}/output/images"
  38. MODULE_DIR="${CODE_DIR}/output/modules"
  39. MANIFEST_DIR="${CODE_DIR}/output/images/sysupgrade"
  40. SITE_GEN_SCRIPT="${CODE_DIR}/packages/ffho/ffho/ffho-site-generate/scripts/gen-site-conf.lua"
  41. SRV_URL="firmware.in.ffho.net"
  42. SRV_USER="firmware"
  43. SRV_PATH="/srv/firmware"
  44. BUILD_INFO_FILENAME="build-info.txt"
  45. SITE_REPO_URL="https://git.ffho.net/freifunkhochstift/ffho-site.git"
  46. LANG=C
  47. pushd ${MY_DIR} > /dev/null
  48. ### set reasonable defaults for unset environment variables
  49. [ -n "${AUTOUPDATER}" ] || AUTOUPDATER=${BRANCH}
  50. if [ -n "${BROKEN}" ]; then
  51. if [ "${BROKEN}" -eq "1" ]; then
  52. export BROKEN
  53. else
  54. unset BROKEN
  55. fi
  56. fi
  57. [ -n "${BUILD_TS}" ] || BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  58. if [ -z "${CLEAN}" ]; then
  59. if [ "${BRANCH}" == "experimental" ]; then
  60. CLEAN="none"
  61. else
  62. CLEAN="clean"
  63. fi
  64. fi
  65. if [ -n "${KEY_DIR}" ]; then
  66. KEY_DIR=$(readlink -f "${KEY_DIR}")
  67. else
  68. KEY_DIR="${DEFAULT_KEY_DIR}"
  69. fi
  70. [ -e "${KEY_DIR}" ] || mkdir -p ${KEY_DIR}
  71. [ "$?" -eq "0" ] || abort "Unable to create key directory: ${KEY_DIR}"
  72. if [ -n "${VERSIONS_DIR}" ]; then
  73. VERSIONS_DIR=$(readlink -f "${VERSIONS_DIR}")
  74. else
  75. VERSIONS_DIR="${DEFAULT_VERSIONS_DIR}"
  76. fi
  77. [ -e "${VERSIONS_DIR}" ] || mkdir -p ${VERSIONS_DIR}
  78. [ "$?" -eq "0" ] || abort "Unable to create versions directory: ${VERSIONS_DIR}"
  79. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  80. [ -n "${PRIORITY}" ] || PRIORITY=0
  81. [ -n "${PUBLISH}" ] || PUBLISH=0
  82. [ -n "${VERBOSE}" ] || VERBOSE=0
  83. MAKE_PARAM=""
  84. [ "${VERBOSE}" -eq "1" ] && MAKE_PARAM="${MAKE_PARAM} V=s"
  85. ### ERROR handling
  86. [ -n "${BASE}" ] || abort "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)."
  87. [ -n "${BRANCH}" ] || abort "Please specify BRANCH environment variable."
  88. [ "${BRANCH}" == "experimental" -o "${BASE}" != "HEAD" ] || abort "HEAD is not an allowed BASE-identifier for non-experimental builds. Either use a tagged commit or the commit-SHA itself."
  89. [ -n "${VERSION}" -o "${BRANCH}" == "experimental" ] || abort "Please specify VERSION environment variable (not necessary for experimental branch)."
  90. [ "${BRANCH}" == "experimental" -o ! -r "${VERSIONS_DIR}/${VERSION}" ] || abort "There exists a version file for '${VERSION}' ... you are trying to do something really stupid, aren't you?"
  91. ### INIT /src IF NECESSARY
  92. if [ ! -d "${CODE_DIR}" ]; then
  93. info "Code directory does not exist yet - fetching Gluon ..."
  94. git clone https://github.com/freifunk-gluon/gluon.git "${CODE_DIR}"
  95. [ "$?" -eq "0" ] || abort "Failed to fetch Gluon repository."
  96. fi
  97. ### INIT /src/site IF NECESSARY
  98. if [ ! -d "${SITE_DIR}" ]; then
  99. info "Site repository does not exist, fetching it ..."
  100. git clone "${SITE_REPO_URL}" "${SITE_DIR}"
  101. [ "$?" -eq "0" ] || abort "Failed to fetch SITE repository."
  102. fi
  103. pushd ${CODE_DIR} > /dev/null
  104. ### CHECKOUT GLUON
  105. progress "Checking out GLUON '${BASE}' ..."
  106. # check if gluon got modified and bail out if necessary
  107. [ "$(git status --porcelain)" ] && abort "Local changes to peers directory. Cowardly refusing to update gluon repository." >&2
  108. git fetch
  109. git checkout -q ${BASE}
  110. [ "$?" -eq "0" ] || abort "Failed to checkout '${BASE}' gluon base version, mimimi." >&2
  111. git show-ref --verify --quiet refs/remotes/origin/${BASE}
  112. if [ "$?" -eq "0" ]; then
  113. git pull
  114. [ "$?" -eq "0" ] || abort "Failed to get newest '${BASE}' in gluon repository, mimimi."
  115. fi
  116. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  117. ### CHECKOUT SITE REPO
  118. progress "Checking out SITE REPO ..."
  119. pushd ${SITE_DIR} > /dev/null
  120. if [ $(git remote | wc -l) -ge "1" ]; then
  121. git fetch
  122. # TODO: check if site got modified locally and bail out if necessary
  123. if [ -z "${SITE_ID}" ]; then
  124. # no specific site given - get the most current one
  125. git checkout -q ${BRANCH}
  126. git branch -r | grep ${BRANCH} > /dev/null
  127. if [ "$?" -eq "0" ]; then
  128. git rebase
  129. [ "$?" -eq "0" ] || abort "Failed to get newest '${BRANCH}' in site repository, mimimi."
  130. fi
  131. else
  132. # fetch site repo updates
  133. git fetch || true
  134. # commit given - use this one
  135. git checkout -q ${SITE_ID}
  136. [ "$?" -eq "0" ] || abort "Failed to checkout requested site commit '${SITE_ID}', mimimi."
  137. fi
  138. fi
  139. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  140. popd > /dev/null #${SITE_DIR}
  141. ### APPLY PATCHES TO GLUON
  142. progress "Applying Patches ..."
  143. git checkout -B patching "${BASE}"
  144. if [ -d "${PATCH_DIR}" -a "$(echo ${PATCH_DIR}/*.patch)" ]; then
  145. git am --whitespace=nowarn ${PATCH_DIR}/*.patch || (
  146. git am --abort
  147. git checkout patched
  148. git branch -D patching
  149. false
  150. )
  151. [ "$?" -eq "0" ] || abort "Failed to apply patches, mimimi."
  152. fi
  153. git branch -M patched
  154. ### DIRCLEAN
  155. if [ -d "${GLUON_BUILD_DIR}/" -a "${CLEAN}" == "dirclean" ]; then
  156. progress "Cleaning your build environment (make dirclean) ..."
  157. make dirclean
  158. fi
  159. ### PREPARE
  160. progress "Preparing the build environment (make update) ..."
  161. make update
  162. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  163. popd > /dev/null #${CODE_DIR}
  164. ### set reasonable defaults for ${TARGETS} and ${BRANCH} if unset
  165. if [ -z "${TARGETS}" ]; then
  166. TARGETS=$(make list-targets | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
  167. info "building all targets: '${TARGETS}'"
  168. fi
  169. if [ "${BRANCH}" == "experimental" -a -z "${VERSION}" ] ; then
  170. VERSION=$(make default-release)
  171. info "EXPERIMENTAL FIRMWARE: using version tag '${VERSION}'"
  172. fi
  173. # we are now ready to produce the firmware images, so let's "save" our state
  174. build_info_path="${VERSIONS_DIR}/${VERSION}"
  175. progress "Saving build information to: ${build_info_path}"
  176. [ -n "${build_info_path}" -a -f "${build_info_path}" ] && rm -f ${build_info_path}
  177. mkdir -p $(dirname ${build_info_path})
  178. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  179. touch $(dirname ${build_info_path})
  180. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  181. echo "VERSION=${VERSION}" >> ${build_info_path}
  182. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  183. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  184. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  185. echo "TARGETS=${TARGETS}" >> ${build_info_path}
  186. echo "TS=${BUILD_TS}" >> ${build_info_path}
  187. ### restore gluon-opkg-key, if already exists
  188. if [ -e "${KEY_DIR}/gluon-opkg-key" -a -e "${KEY_DIR}/gluon-opkg-key.pub" ]; then
  189. info "gluon-opkg-key already exists, restoring it."
  190. mkdir -p ${GLUON_BUILD_DIR}/
  191. [ "$?" -eq "0" ] || abort "Unable to create directory: ${GLUON_BUILD_DIR}/"
  192. cp -f ${KEY_DIR}/gluon-opkg-key* ${GLUON_BUILD_DIR}/
  193. [ "$?" -eq "0" ] || abort "Unable to copy gluon-opkg-key."
  194. fi
  195. ### create site.conf
  196. if [ -x "${SITE_GEN_SCRIPT}" ]; then
  197. progress "Generating defaut site.conf"
  198. eval GLUON_SITEDIR=${SITE_DIR} ${SITE_GEN_SCRIPT}
  199. fi
  200. ### BUILD FIRMWARE
  201. progress "Building the firmware - please stand by!"
  202. pushd ${CODE_DIR} > /dev/null
  203. for target in ${TARGETS} ; do
  204. # configure build environment for our current target
  205. export GLUON_TARGET="${target}"
  206. export GLUON_RELEASE="${VERSION}"
  207. [ "${AUTOUPDATER}" != "off" ] && export GLUON_BRANCH="${AUTOUPDATER}"
  208. # prepare build environment for our current target
  209. progress "${target}: Preparing build environment."
  210. if [ "${CLEAN}" == "clean" ]; then
  211. make clean
  212. [ "$?" -eq "0" ] || abort "${target}: Unable to clean environment."
  213. fi
  214. make -j ${MAKEJOBS} prepare-target ${MAKE_PARAM}
  215. [ "$?" -eq "0" ] || abort "${target}: Unable to build environment."
  216. # need to have a toolchain for the particular target
  217. progress "${target}: Building toolchain."
  218. make -j ${MAKEJOBS} toolchain/install ${MAKE_PARAM}
  219. [ "$?" -eq "0" ] || abort "${target}: Unable to build toolchain."
  220. # now we can start building the images for the target platform
  221. progress "${target}: Building FFHO-flavoured Gluon firmware. You'd better go and fetch some c0ffee!"
  222. make -j ${MAKEJOBS} prepare ${MAKE_PARAM}
  223. [ "$?" -eq "0" ] || abort "${target}: Unable to build firmware."
  224. # finally compile the firmware binaries
  225. progress "${target}: Compiling binary firmware images."
  226. make -j ${MAKEJOBS} images ${MAKE_PARAM}
  227. [ "$?" -eq "0" ] || abort "${target}: Unable to assemble images."
  228. # compile the modules
  229. progress "${target}: Compiling modules."
  230. make -j ${MAKEJOBS} modules ${MAKE_PARAM}
  231. [ "$?" -eq "0" ] || abort "${target}: Unable to build modules."
  232. done
  233. # generate manifest
  234. progress "Generating manifest ..."
  235. GLUON_PRIORITY=${PRIORITY} GLUON_BRANCH=${BRANCH} make manifest
  236. [ "$?" -eq "0" ] || abort "Failed to generate the manifest."
  237. popd > /dev/null #${CODE_DIR}
  238. if [ "${PUBLISH}" -eq "1" ]; then
  239. # copying firmware to the server
  240. if [ -d "${IMAGE_DIR}" ]; then
  241. progress "Copying the firmware ..."
  242. rsync -rlutzc --exclude=*manifest -e ssh ${IMAGE_DIR}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}
  243. [ "$?" -eq "0" ] || abort "Failed to copy the firmware."
  244. fi
  245. # copying modules to the server
  246. if [ -d "${MODULE_DIR}" ]; then
  247. progress "Copying the modules ..."
  248. rsync -rlutzc -e ssh ${MODULE_DIR}/gluon-ffho-${VERSION}/ ${SRV_USER}@${SRV_URL}:${SRV_PATH}/${VERSION}/modules
  249. [ "$?" -eq "0" ] || abort "Failed to copy the modules."
  250. fi
  251. # copy manifest and the build info file
  252. progress "Copying manifest and build info file ..."
  253. pushd ${OUTPUT_DIR} > /dev/null
  254. git fetch
  255. git checkout -q signing
  256. git merge --ff-only origin/master
  257. mkdir -p "${OUTPUT_DIR}/${VERSION}/sysupgrade"
  258. cp -f "${MANIFEST_DIR}/${BRANCH}.manifest" "${OUTPUT_DIR}/${VERSION}/sysupgrade/"
  259. cp -f "${build_info_path}" "${OUTPUT_DIR}/${VERSION}/${BUILD_INFO_FILENAME}"
  260. popd > /dev/null #${OUTPUT_DIR}
  261. # Update symlinks
  262. progress "Update symlink for ${BRANCH}"
  263. pushd ${OUTPUT_DIR} > /dev/null
  264. ln -fsn ${VERSION} ${BRANCH}
  265. popd > /dev/null #${OUTPUT_DIR}
  266. fi
  267. # Saving a copy of gluon-opkg-key
  268. [ -e "${KEY_DIR}/gluon-opkg-key" -a -e "${KEY_DIR}/gluon-opkg-key.pub" ] || cp ${GLUON_BUILD_DIR}/gluon-opkg-key* ${KEY_DIR}/
  269. [ "$?" -eq "0" ] || abort "Failed to save gluon-opkg-key, try to execute 'cp ${GLUON_BUILD_DIR}/gluon-opkg-key* ${KEY_DIR}/' manually"
  270. # The end. Finally.
  271. success "We're done, go and enjoy your new firmware (${VERSION})!"
  272. popd > /dev/null #${MY_DIR}